#include "rotatenode.h"
#include <math.h>

RotateNode::RotateNode(GLdouble angle, GLdouble x, GLdouble y, GLdouble z, std::string name) : TransformNode(name)
{
//    this->type = "RotateNode";
    this->angle = angle;
    this->x = x;
    this->y = y;
    this->z = z;
    updateMatrix();
}


RotateNode::RotateNode(float *mat, std::string name) : TransformNode(name)
{
    for (int i=0; i<16; i++)
    {
        matrix[i] = mat[i];
    }
}

RotateNode::~RotateNode(){    

}


void RotateNode::updateMatrix(){
    // according to http://www.opengl.org/sdk/docs/man/xhtml/glRotate.xml
    GLfloat s = sin(angle * M_PI / 180.0);
    GLfloat c = cos(angle * M_PI / 180.0);
    matrix[0] = x*x*(1-c)+c;
    matrix[1] = x*y*(1-c)+z*s;
    matrix[2] = x*z*(1-c)-y*s;
    matrix[3] = 0;
    matrix[4] = y*x*(1-c)-z*s;
    matrix[5] = y*y*(1-c)+c;
    matrix[6] = y*z*(1-c)+x*s;
    matrix[7] = 0;
    matrix[8] = z*x*(1-c)+y*s;
    matrix[9] = z*y*(1-c)-x*s;
    matrix[10] = z*z*(1-c)+c;
    matrix[11] = 0;
    matrix[12] = 0;
    matrix[13] = 0;
    matrix[14] = 0;
    matrix[15] = 1;
}

